=begin
#KORONA.cloud API v3

#Our api provides access to our cloud services

OpenAPI spec version: 2.11.21

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.8

=end

require 'uri'

module KoronaClient
  class CommodityGroupsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # adds a batch of new commodity groups
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param body an array of new commodity groups
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :upsert when set to true, updates the object instead of generating a already-exists-error
    # @return [Array<AddOrUpdateResult>]
    def add_commodity_groups(korona_account_id, body, opts = {})
      data, _status_code, _headers = add_commodity_groups_with_http_info(korona_account_id, body, opts)
      data
    end

    # adds a batch of new commodity groups
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param body an array of new commodity groups
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :upsert when set to true, updates the object instead of generating a already-exists-error
    # @return [Array<(Array<AddOrUpdateResult>, Fixnum, Hash)>] Array<AddOrUpdateResult> data, response status code and response headers
    def add_commodity_groups_with_http_info(korona_account_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CommodityGroupsApi.add_commodity_groups ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling CommodityGroupsApi.add_commodity_groups"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling CommodityGroupsApi.add_commodity_groups"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/commodityGroups'.sub('{' + 'koronaAccountId' + '}', korona_account_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'upsert'] = opts[:'upsert'] if !opts[:'upsert'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['basicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<AddOrUpdateResult>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CommodityGroupsApi#add_commodity_groups\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # deletes the single commodity group
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param commodity_group_id id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_commodity_group(korona_account_id, commodity_group_id, opts = {})
      delete_commodity_group_with_http_info(korona_account_id, commodity_group_id, opts)
      nil
    end

    # deletes the single commodity group
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param commodity_group_id id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_commodity_group_with_http_info(korona_account_id, commodity_group_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CommodityGroupsApi.delete_commodity_group ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling CommodityGroupsApi.delete_commodity_group"
      end
      # verify the required parameter 'commodity_group_id' is set
      if @api_client.config.client_side_validation && commodity_group_id.nil?
        fail ArgumentError, "Missing the required parameter 'commodity_group_id' when calling CommodityGroupsApi.delete_commodity_group"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/commodityGroups/{commodityGroupId}'.sub('{' + 'koronaAccountId' + '}', korona_account_id.to_s).sub('{' + 'commodityGroupId' + '}', commodity_group_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['basicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CommodityGroupsApi#delete_commodity_group\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # deletes a batch of commodity groups
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param body array of existing commodity groups (id or number required)
    # @param [Hash] opts the optional parameters
    # @return [Array<AddOrUpdateResult>]
    def delete_commodity_groups(korona_account_id, body, opts = {})
      data, _status_code, _headers = delete_commodity_groups_with_http_info(korona_account_id, body, opts)
      data
    end

    # deletes a batch of commodity groups
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param body array of existing commodity groups (id or number required)
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<AddOrUpdateResult>, Fixnum, Hash)>] Array<AddOrUpdateResult> data, response status code and response headers
    def delete_commodity_groups_with_http_info(korona_account_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CommodityGroupsApi.delete_commodity_groups ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling CommodityGroupsApi.delete_commodity_groups"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling CommodityGroupsApi.delete_commodity_groups"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/commodityGroups'.sub('{' + 'koronaAccountId' + '}', korona_account_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['basicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<AddOrUpdateResult>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CommodityGroupsApi#delete_commodity_groups\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # returns the single commodity group
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param commodity_group_id id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [CommodityGroup]
    def get_commodity_group(korona_account_id, commodity_group_id, opts = {})
      data, _status_code, _headers = get_commodity_group_with_http_info(korona_account_id, commodity_group_id, opts)
      data
    end

    # returns the single commodity group
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param commodity_group_id id of the related object (important: id should match the uuid-format)
    # @param [Hash] opts the optional parameters
    # @return [Array<(CommodityGroup, Fixnum, Hash)>] CommodityGroup data, response status code and response headers
    def get_commodity_group_with_http_info(korona_account_id, commodity_group_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CommodityGroupsApi.get_commodity_group ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling CommodityGroupsApi.get_commodity_group"
      end
      # verify the required parameter 'commodity_group_id' is set
      if @api_client.config.client_side_validation && commodity_group_id.nil?
        fail ArgumentError, "Missing the required parameter 'commodity_group_id' when calling CommodityGroupsApi.get_commodity_group"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/commodityGroups/{commodityGroupId}'.sub('{' + 'koronaAccountId' + '}', korona_account_id.to_s).sub('{' + 'commodityGroupId' + '}', commodity_group_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['basicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CommodityGroup')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CommodityGroupsApi#get_commodity_group\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # lists all commodity groups
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page number of the page to fetch
    # @option opts [Integer] :size amount of objects to return per page
    # @option opts [String] :sort attribute to sort by (multiple separated by comma; max. 5)
    # @option opts [Integer] :revision last revision number, objects with a greater revision than this will be returned
    # @option opts [BOOLEAN] :include_deleted indicates deleted objects should be loaded or not (default: false)
    # @option opts [String] :number number of the related object
    # @return [ResultListCommodityGroup]
    def get_commodity_groups(korona_account_id, opts = {})
      data, _status_code, _headers = get_commodity_groups_with_http_info(korona_account_id, opts)
      data
    end

    # lists all commodity groups
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page number of the page to fetch
    # @option opts [Integer] :size amount of objects to return per page
    # @option opts [String] :sort attribute to sort by (multiple separated by comma; max. 5)
    # @option opts [Integer] :revision last revision number, objects with a greater revision than this will be returned
    # @option opts [BOOLEAN] :include_deleted indicates deleted objects should be loaded or not (default: false)
    # @option opts [String] :number number of the related object
    # @return [Array<(ResultListCommodityGroup, Fixnum, Hash)>] ResultListCommodityGroup data, response status code and response headers
    def get_commodity_groups_with_http_info(korona_account_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CommodityGroupsApi.get_commodity_groups ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling CommodityGroupsApi.get_commodity_groups"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/commodityGroups'.sub('{' + 'koronaAccountId' + '}', korona_account_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
      query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?
      query_params[:'revision'] = opts[:'revision'] if !opts[:'revision'].nil?
      query_params[:'includeDeleted'] = opts[:'include_deleted'] if !opts[:'include_deleted'].nil?
      query_params[:'number'] = opts[:'number'] if !opts[:'number'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['basicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ResultListCommodityGroup')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CommodityGroupsApi#get_commodity_groups\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # updates the single commodity group
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param commodity_group_id id of the related object (important: id should match the uuid-format)
    # @param body the properties to update of the commodity group
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def update_commodity_group(korona_account_id, commodity_group_id, body, opts = {})
      update_commodity_group_with_http_info(korona_account_id, commodity_group_id, body, opts)
      nil
    end

    # updates the single commodity group
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param commodity_group_id id of the related object (important: id should match the uuid-format)
    # @param body the properties to update of the commodity group
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def update_commodity_group_with_http_info(korona_account_id, commodity_group_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CommodityGroupsApi.update_commodity_group ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling CommodityGroupsApi.update_commodity_group"
      end
      # verify the required parameter 'commodity_group_id' is set
      if @api_client.config.client_side_validation && commodity_group_id.nil?
        fail ArgumentError, "Missing the required parameter 'commodity_group_id' when calling CommodityGroupsApi.update_commodity_group"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling CommodityGroupsApi.update_commodity_group"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/commodityGroups/{commodityGroupId}'.sub('{' + 'koronaAccountId' + '}', korona_account_id.to_s).sub('{' + 'commodityGroupId' + '}', commodity_group_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['basicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CommodityGroupsApi#update_commodity_group\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # updates a batch of commodity groups
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param body array of existing commodity groups (id or number required)
    # @param [Hash] opts the optional parameters
    # @return [Array<AddOrUpdateResult>]
    def update_commodity_groups(korona_account_id, body, opts = {})
      data, _status_code, _headers = update_commodity_groups_with_http_info(korona_account_id, body, opts)
      data
    end

    # updates a batch of commodity groups
    # 
    # @param korona_account_id account id of the KORONA.cloud account
    # @param body array of existing commodity groups (id or number required)
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<AddOrUpdateResult>, Fixnum, Hash)>] Array<AddOrUpdateResult> data, response status code and response headers
    def update_commodity_groups_with_http_info(korona_account_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CommodityGroupsApi.update_commodity_groups ...'
      end
      # verify the required parameter 'korona_account_id' is set
      if @api_client.config.client_side_validation && korona_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'korona_account_id' when calling CommodityGroupsApi.update_commodity_groups"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling CommodityGroupsApi.update_commodity_groups"
      end
      # resource path
      local_var_path = '/accounts/{koronaAccountId}/commodityGroups'.sub('{' + 'koronaAccountId' + '}', korona_account_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['basicAuth']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<AddOrUpdateResult>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CommodityGroupsApi#update_commodity_groups\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
