=begin
#KORONA.cloud API v3

#Our api provides access to our cloud services

OpenAPI spec version: 2.11.21

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.8

=end

require 'date'

module KoronaClient
  class Inventory
    # indicates whether the object is active for use or not
    attr_accessor :active

    # global object uuid (xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx)
    attr_accessor :id

    # number of the object, like it is set in backoffice; will be removed when active=false
    attr_accessor :number

    # the revision number of the object. revision numbers are unique per object-type. there is is no object of the same type with identical revision numbers.
    attr_accessor :revision

    attr_accessor :automatic_booking

    # only if isAutomaticBooking=true
    attr_accessor :automatic_booking_after_days

    attr_accessor :check_product_assortment_validity

    attr_accessor :check_product_listing

    attr_accessor :create_time

    attr_accessor :description

    # only if type=PERPETUAL_INVENTORY
    attr_accessor :execution_days

    attr_accessor :execution_time

    attr_accessor :has_booked_receipts

    # only if type=ANNUAL_INVENTORY | INVENTORY_IRREGULARITY
    attr_accessor :max_products_per_list

    # only if type=ANNUAL_INVENTORY | INVENTORY_IRREGULARITY
    attr_accessor :one_commodity_group_per_inventory_list

    # only if type=INVENTORY_IRREGULARITY
    attr_accessor :only_negative_product_stocks

    attr_accessor :organizational_units

    attr_accessor :product_filter

    attr_accessor :type

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'active' => :'active',
        :'id' => :'id',
        :'number' => :'number',
        :'revision' => :'revision',
        :'automatic_booking' => :'automaticBooking',
        :'automatic_booking_after_days' => :'automaticBookingAfterDays',
        :'check_product_assortment_validity' => :'checkProductAssortmentValidity',
        :'check_product_listing' => :'checkProductListing',
        :'create_time' => :'createTime',
        :'description' => :'description',
        :'execution_days' => :'executionDays',
        :'execution_time' => :'executionTime',
        :'has_booked_receipts' => :'hasBookedReceipts',
        :'max_products_per_list' => :'maxProductsPerList',
        :'one_commodity_group_per_inventory_list' => :'oneCommodityGroupPerInventoryList',
        :'only_negative_product_stocks' => :'onlyNegativeProductStocks',
        :'organizational_units' => :'organizationalUnits',
        :'product_filter' => :'productFilter',
        :'type' => :'type'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'active' => :'BOOLEAN',
        :'id' => :'String',
        :'number' => :'String',
        :'revision' => :'Integer',
        :'automatic_booking' => :'BOOLEAN',
        :'automatic_booking_after_days' => :'Integer',
        :'check_product_assortment_validity' => :'BOOLEAN',
        :'check_product_listing' => :'BOOLEAN',
        :'create_time' => :'DateTime',
        :'description' => :'String',
        :'execution_days' => :'Array<String>',
        :'execution_time' => :'DateTime',
        :'has_booked_receipts' => :'BOOLEAN',
        :'max_products_per_list' => :'Integer',
        :'one_commodity_group_per_inventory_list' => :'BOOLEAN',
        :'only_negative_product_stocks' => :'BOOLEAN',
        :'organizational_units' => :'Array<ModelReference>',
        :'product_filter' => :'String',
        :'type' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'active')
        self.active = attributes[:'active']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'number')
        self.number = attributes[:'number']
      end

      if attributes.has_key?(:'revision')
        self.revision = attributes[:'revision']
      end

      if attributes.has_key?(:'automaticBooking')
        self.automatic_booking = attributes[:'automaticBooking']
      end

      if attributes.has_key?(:'automaticBookingAfterDays')
        self.automatic_booking_after_days = attributes[:'automaticBookingAfterDays']
      end

      if attributes.has_key?(:'checkProductAssortmentValidity')
        self.check_product_assortment_validity = attributes[:'checkProductAssortmentValidity']
      end

      if attributes.has_key?(:'checkProductListing')
        self.check_product_listing = attributes[:'checkProductListing']
      end

      if attributes.has_key?(:'createTime')
        self.create_time = attributes[:'createTime']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'executionDays')
        if (value = attributes[:'executionDays']).is_a?(Array)
          self.execution_days = value
        end
      end

      if attributes.has_key?(:'executionTime')
        self.execution_time = attributes[:'executionTime']
      end

      if attributes.has_key?(:'hasBookedReceipts')
        self.has_booked_receipts = attributes[:'hasBookedReceipts']
      end

      if attributes.has_key?(:'maxProductsPerList')
        self.max_products_per_list = attributes[:'maxProductsPerList']
      end

      if attributes.has_key?(:'oneCommodityGroupPerInventoryList')
        self.one_commodity_group_per_inventory_list = attributes[:'oneCommodityGroupPerInventoryList']
      end

      if attributes.has_key?(:'onlyNegativeProductStocks')
        self.only_negative_product_stocks = attributes[:'onlyNegativeProductStocks']
      end

      if attributes.has_key?(:'organizationalUnits')
        if (value = attributes[:'organizationalUnits']).is_a?(Array)
          self.organizational_units = value
        end
      end

      if attributes.has_key?(:'productFilter')
        self.product_filter = attributes[:'productFilter']
      end

      if attributes.has_key?(:'type')
        self.type = attributes[:'type']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      product_filter_validator = EnumAttributeValidator.new('String', ['ACTIVE', 'ALL', 'DEACTIVATED'])
      return false unless product_filter_validator.valid?(@product_filter)
      type_validator = EnumAttributeValidator.new('String', ['ANNUAL_INVENTORY', 'INVENTORY_IRREGULARITY', 'INVENTORY_SAMPLING', 'PERPETUAL_INVENTORY'])
      return false unless type_validator.valid?(@type)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] product_filter Object to be assigned
    def product_filter=(product_filter)
      validator = EnumAttributeValidator.new('String', ['ACTIVE', 'ALL', 'DEACTIVATED'])
      unless validator.valid?(product_filter)
        fail ArgumentError, 'invalid value for "product_filter", must be one of #{validator.allowable_values}.'
      end
      @product_filter = product_filter
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      validator = EnumAttributeValidator.new('String', ['ANNUAL_INVENTORY', 'INVENTORY_IRREGULARITY', 'INVENTORY_SAMPLING', 'PERPETUAL_INVENTORY'])
      unless validator.valid?(type)
        fail ArgumentError, 'invalid value for "type", must be one of #{validator.allowable_values}.'
      end
      @type = type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          active == o.active &&
          id == o.id &&
          number == o.number &&
          revision == o.revision &&
          automatic_booking == o.automatic_booking &&
          automatic_booking_after_days == o.automatic_booking_after_days &&
          check_product_assortment_validity == o.check_product_assortment_validity &&
          check_product_listing == o.check_product_listing &&
          create_time == o.create_time &&
          description == o.description &&
          execution_days == o.execution_days &&
          execution_time == o.execution_time &&
          has_booked_receipts == o.has_booked_receipts &&
          max_products_per_list == o.max_products_per_list &&
          one_commodity_group_per_inventory_list == o.one_commodity_group_per_inventory_list &&
          only_negative_product_stocks == o.only_negative_product_stocks &&
          organizational_units == o.organizational_units &&
          product_filter == o.product_filter &&
          type == o.type
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [active, id, number, revision, automatic_booking, automatic_booking_after_days, check_product_assortment_validity, check_product_listing, create_time, description, execution_days, execution_time, has_booked_receipts, max_products_per_list, one_commodity_group_per_inventory_list, only_negative_product_stocks, organizational_units, product_filter, type].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = KoronaClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
