=begin
#KORONA.cloud API v3

#Our api provides access to our cloud services

OpenAPI spec version: 2.11.21

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.8

=end

require 'date'

module KoronaClient
  class ReceiptItem
    attr_accessor :booking_time

    attr_accessor :commodity_group

    attr_accessor :indent

    attr_accessor :info_texts

    attr_accessor :discounts

    attr_accessor :manual_price

    attr_accessor :product

    attr_accessor :quantity

    attr_accessor :recognition_number

    attr_accessor :sector

    attr_accessor :serial_numbers

    attr_accessor :total

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'booking_time' => :'bookingTime',
        :'commodity_group' => :'commodityGroup',
        :'indent' => :'indent',
        :'info_texts' => :'infoTexts',
        :'discounts' => :'discounts',
        :'manual_price' => :'manualPrice',
        :'product' => :'product',
        :'quantity' => :'quantity',
        :'recognition_number' => :'recognitionNumber',
        :'sector' => :'sector',
        :'serial_numbers' => :'serialNumbers',
        :'total' => :'total'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'booking_time' => :'DateTime',
        :'commodity_group' => :'ModelReference',
        :'indent' => :'Integer',
        :'info_texts' => :'Array<String>',
        :'discounts' => :'Array<Discount>',
        :'manual_price' => :'BOOLEAN',
        :'product' => :'ModelReference',
        :'quantity' => :'Float',
        :'recognition_number' => :'String',
        :'sector' => :'ModelReference',
        :'serial_numbers' => :'Array<String>',
        :'total' => :'TotalPrice'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'bookingTime')
        self.booking_time = attributes[:'bookingTime']
      end

      if attributes.has_key?(:'commodityGroup')
        self.commodity_group = attributes[:'commodityGroup']
      end

      if attributes.has_key?(:'indent')
        self.indent = attributes[:'indent']
      end

      if attributes.has_key?(:'infoTexts')
        if (value = attributes[:'infoTexts']).is_a?(Array)
          self.info_texts = value
        end
      end

      if attributes.has_key?(:'discounts')
        if (value = attributes[:'discounts']).is_a?(Array)
          self.discounts = value
        end
      end

      if attributes.has_key?(:'manualPrice')
        self.manual_price = attributes[:'manualPrice']
      end

      if attributes.has_key?(:'product')
        self.product = attributes[:'product']
      end

      if attributes.has_key?(:'quantity')
        self.quantity = attributes[:'quantity']
      end

      if attributes.has_key?(:'recognitionNumber')
        self.recognition_number = attributes[:'recognitionNumber']
      end

      if attributes.has_key?(:'sector')
        self.sector = attributes[:'sector']
      end

      if attributes.has_key?(:'serialNumbers')
        if (value = attributes[:'serialNumbers']).is_a?(Array)
          self.serial_numbers = value
        end
      end

      if attributes.has_key?(:'total')
        self.total = attributes[:'total']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          booking_time == o.booking_time &&
          commodity_group == o.commodity_group &&
          indent == o.indent &&
          info_texts == o.info_texts &&
          discounts == o.discounts &&
          manual_price == o.manual_price &&
          product == o.product &&
          quantity == o.quantity &&
          recognition_number == o.recognition_number &&
          sector == o.sector &&
          serial_numbers == o.serial_numbers &&
          total == o.total
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [booking_time, commodity_group, indent, info_texts, discounts, manual_price, product, quantity, recognition_number, sector, serial_numbers, total].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = KoronaClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
